<?php

// hey ! on as du texte wiki ici ... ;)
$objWiki = new wiki2xhtml();

if (strpos($_SESSION['sess_user_lang'],'fr') === 0)
	$objWiki->setOpt('active_fr_syntax',1);
	
if (dc_encoding != 'UTF-8')
	$objWiki->setOpt('active_fix_word_entities',1);

// initialisations ...
$url = 'tools.php?p=homemessage';
$file = DC_SHARE_DIR.'/homemessage/homemessage.txt';
$cache = DC_SHARE_DIR.'/homemessage/cache.txt';

$p_title = '';
$p_content = '';

$edited = false;
$edited_c = false;

// si le fichier n'existe pas on tente de le crer
if (!file_exists($file))
{
	if (isset($_GET['install']))
	{
		$my_share_dir = DC_SHARE_DIR.'/homemessage';
		
		if (!is_dir($my_share_dir))
		{
			$failed = true;
			if (is_writeable(DC_SHARE_DIR))
			{
				@umask(000);
				if (@mkdir($my_share_dir, 0777))
				{
					$failed = false;
					
					if ($fh = @fopen($my_share_dir.'/.htaccess',"wb"))
					{
						fwrite($fh,"Deny from all\n");
						fclose($fh);
					}
					
					if ($fh = @fopen($file,"wb"))
					{
						fwrite($fh,"wiki|title: Titre accueil\n\nContenu message accueil");
						fclose($fh);
					}
					
					if ($fh = @fopen($cache,"wb"))
					{
						fwrite($fh,"<h2>Titre accueil</h2>\n\n<p>Contenu message accueil</p>");
						fclose($fh);
					}
				}
			}
			
			if ($failed)
			{
				buffer::str('<h2>'.__('Home message').'</h2>');
				buffer::str(
					'<div class="erreur"><p><strong>'.
					__('Unavailable homemessage/ directory in share/. You may create it manually and/or give it writing rights.').
					'</strong></p>'.
					'</div>'
				);
			}
			else {
				header('Location: '.$url);
				exit;
			}
		}
	}
	else {
		buffer::str('<h2>'.__('Home message').'</h2>');
		buffer::str('<p>'.__('The plugin does not seems to be correctly installed.').'</p>');
		buffer::str('<p><a href="'.$url.'&amp;install=1">'.__('Install').'</a></p>');
	}
}

// le fichier existe alors on s'occupe du plugin en lui-mme
else
{
	// Modification du fichier
	if (isset($_POST['publish']))
	{
		$p_title = trim($_POST['p_title']);
		$p_content = trim($_POST['p_content']);
		$p_format = $_POST['p_format'];
		
		
		// nouveau contenu de travail
		$neo_content = $p_format.'|title:'.$p_title."\n\n".$p_content;
		
		// nouveau contenu de cache
		$neo_cache = '';
		if ($p_title != '')
			$neo_cache .= '<h2>'.$p_title.'</h2>';
		
		if ($p_format == 'wiki')
			$neo_cache .= $objWiki->transform($p_content);
		else
			$neo_cache .= $p_content;
			
		
		// criture du fichier de travail
		if (!$handle = @fopen($file, 'w'))
			$err = __('Cannot open file').' '.$file;
		else
		{
			if (fwrite($handle, $neo_content) === FALSE)
				$err = __('Cannot write to file').' '.$file;
			else
				$edited = true;
			
			fclose($handle);
		}
		
		
		// criture du fichier cache
		if (!$handle = @fopen($cache, 'w'))
			$err = __('Cannot open file').' '.$cache;
		else
		{
			if (fwrite($handle, $neo_cache) === FALSE)
				$err = __('Cannot write to file').' '.$cache;
			else
				$edited_c = true;
			
			fclose($handle);
		}
	
	}
	
	// Prvisualisation
	if (isset($_POST['preview']))
	{
		$p_title = trim($_POST['p_title']);
		$p_content = trim($_POST['p_content']);
		$p_format = $_POST['p_format'];
		
		// contenu de prvisualisation
		$preview_content = '';
		
		if ($p_title != '')
			$preview_content .= '<h2>'.$p_title.'</h2>';
		
		if ($p_format == 'wiki')
			$preview_content .= $objWiki->transform($p_content);
		else
			$preview_content .= $p_content;
	}
	else {
		$content = file_get_contents($file);
		
		$first_line = strpos($content, "\n");
		$p_title = trim(substr($content, 11, $first_line-11));
		$p_format = trim(substr($content, 0, 4));
		$p_content = trim(substr($content, $first_line));
				
		// contenu de prvisualisation
		$preview_content = '';
		
		if ($p_title != '')
			$preview_content .= '<h2>'.$p_title.'</h2>';
		
		if ($p_format == 'wiki')
			$preview_content .= $objWiki->transform($p_content);
		else
			$preview_content .= $p_content;
	}
	
	// Affichage
	buffer::str('<h2>'.__('Home message').'</h2>');
	
	if ($edited && $edited_c)
		buffer::str('<p class="message">'.__('Home page successfully updated').'</p>');
		
	if (isset($err) && $err != '')
		buffer::str('<div class="erreur"><p><strong>'.__('Error(s)').' :</strong></p><p>'.$err.'</p></div>');
	
	buffer::str('<div class="cadre preview clear">'.$preview_content.'</div>');
		
	buffer::str(
		'<form action="'.$url.'" method="post">'."\n".
		'<fieldset class="clear">'."\n".
		'<legend>'.__('Edit a message for your home page').'</legend>'."\n\n".
		
		'<p class="field"><label for="p_title"><strong>'.__('Title').'</strong></label>'."\n".
		form::field('p_title',60,'',$p_title,'','class="max"').'</p>'."\n\n".
		
		'<p class="field"><label for="p_format">'.__('Format').'</label>'.
		form::combo('p_format',array('HTML'=>'html','Wiki'=>'wiki'),$p_format,'','',2)."\n\n".
		
		'<p><label for="p_content"><strong>'.__('Content').'</strong>'.
		' - '.helpLink('wiki2xhtml','',__('Wiki formatting rules')).
		'</label></p><p>'."\n".
		form::textArea('p_content',60,$_SESSION['sess_user_edit_size'],$p_content,'','class="max"').'</p>'."\n".
		'</fieldset>'.
	
		'<p><input name="preview" type="submit" class="submit" '.
		'value="'.__('preview').' [v]" accesskey="v" />&nbsp; '.
		'<input name="publish" type="submit" class="submit" '.
		'value="'.__('save').' [s]" accesskey="s" /></p>'.
		'<p>'.dcNonce::form().'</p>'.
		'</form>'
	);
				
	// Affiche la Toolbar
	buffer::str(
		'<script type="text/javascript" src="js/toolbar.js"></script>'.
		'<script type="text/javascript">'.
		"if (document.getElementById) {
			var tb = new dcToolBar(document.getElementById('p_content'),document.getElementById('p_format'),'images/');
			
			tb.btStrong('".str_replace("'","\'",__('Strong emphasis'))."');
			tb.btEm('".str_replace("'","\'",__('Emphasis'))."');
			tb.btIns('".str_replace("'","\'",__('Inserted'))."');
			tb.btDel('".str_replace("'","\'",__('Deleted'))."');
			tb.btQ('".str_replace("'","\'",__('Inline quote'))."');
			tb.btCode('".str_replace("'","\'",__('Code'))."');
			tb.addSpace(10);
			tb.btBr('".str_replace("'","\'",__('Line break'))."');
			tb.addSpace(10);
			tb.btBquote('".str_replace("'","\'",__('Blockquote'))."');
			tb.btPre('".str_replace("'","\'",__('Preformated text'))."');
			tb.btList('".str_replace("'","\'",__('Unordered list'))."','ul');
			tb.btList('".str_replace("'","\'",__('Ordered list'))."','ol');
			tb.addSpace(10);
			tb.btLink('".str_replace("'","\'",__('Link'))."',
				'".str_replace("'","\'",__('URL?'))."',
				'".str_replace("'","\'",__('Language?'))."',
				'".DC_LANG."');
			tb.btImgLink('".str_replace("'","\'",__('External image'))."',
				'".str_replace("'","\'",__('URL?'))."');
			tb.addSpace(10);
			tb.draw('".str_replace("'","\'",'')."');
		}
		</script>"
	);
	
	buffer::str(
		'<h3>'.__('Usage').'</h3>'.
		'<p>'.__('Insert in your template.php file\'s theme the function below where you want the message to appear.').'</p>'.
		'<pre>'.htmlspecialchars('<?php dcHomeMessage::fetchMessage(); ?>').'</pre>'
	);

}
?>